require 'base.scripts.util'
require 'base.scripts.oop'

-- todo - put this in gameapi or client or something?

-- no class refs with the key stuff
-- its too complex (and proly slow too)
-- and its messing up my manip between classes and instances
-- so I'm hacking the class construction

local BUTTON_STATE = enum({'UP','DOWN','PRESS','RELEASE'},0)


ClientKeyTrigger = {}
ClientKeyTrigger.paramToState = {
	isPressed = BUTTON_STATE.PRESS;
	isDown = BUTTON_STATE.DOWN;
	isUp = BUTTON_STATE.UP;
	isReleased = BUTTON_STATE.RELEASE;
}
function ClientKeyTrigger.new()
	local t = {cmd = 0}
	setmetatable(t, ClientKeyTrigger)
	return t
end
function ClientKeyTrigger:__index(param)
	return rawget(self, 'cmd') == ClientKeyTrigger.paramToState[param]
end
function ClientKeyTrigger.__newindex() end	-- no new values


ClientKeyHandler = {}
ClientKeyHandler.keys = getClientKeyMap()	--engine-bound
function ClientKeyHandler.new()
	local t = {
		cmd = 0;
		trigger = ClientKeyTrigger:new();
	}
	setmetatable(t, ClientKeyHandler)
	return t
end
function ClientKeyHandler:__index(param)
	local i = ClientKeyHandler.keys[param]
	if i ~= nil then
		-- set our current calc'd key (not mt safe!) to i
		-- and return a hidden meta table ready to handle the is*** trigger that should come next
		local trigger = rawget(self, 'trigger')
		rawset(trigger, 'cmd', bitand(bitshiftright(rawget(self, 'cmd'), 2*i), 3))
		return trigger
	end
end
function ClientKeyHandler.__newindex() end	-- dont allow any new values


class('ClientInput')

ClientInput.__index = ClientInput
function ClientInput.__newindex() end

function ClientInput:ctor()
	rawset(self, 'key', ClientKeyHandler:new())
	rawset(self, 'mouse', {active = false; pos = vec2:new();})
end
function ClientInput:setcmd(inputcmd)
	rawset(self.key, 'cmd', inputcmd)
end
function ClientInput:fill(inputcmd,mouseactive,mouseposx,mouseposy)
	self:setcmd(inputcmd)
	self.mouse.active = mouseactive
	self.mouse.pos[1] = mouseposx
	self.mouse.pos[2] = mouseposy
end
function ClientInput:copyFrom(src)
	self:fill(
		src.key.cmd,
		src.mouse.active,
		unpack(src.mouse.pos))
end
