require 'base.scripts.util'

local function classobjNew(self, ...)	-- self is the class
	local inst = {class=self.class}
	setmetatable(inst, self.class)
	if inst.ctor then inst:ctor(...) end
	return inst
end

local function classobjIsA(self, theClass)
	local curClass = self.class
	while curClass do
		if curClass == theClass then return true end
		curClass = curClass.super
	end
	return false
end

function class(classname, parent, contents)
	local classobj = {}	
	
	-- start off by just copying everything from parent into the new classobj
	if parent then union(classobj, parent) end
	
	-- then override all the stuff we have ourselves:
	classobj.classname = classname
	classobj.__index = classobj
	classobj.class = classobj		-- used for class referencing.  tempting to replace with getmetatable() ...
	classobj.new = classobjNew
	classobj.isa = classobjIsA
	classobj.super = parent

	-- and then override it with what the user passes us.  do this after giving it the parents stuff.  and after the defaults?
	if contents then union(classobj, contents) end
	
	-- register the class with the global object
	_G[classname] = classobj
	
	-- throw er back
	return classobj
end
