require 'base.scripts.ents'
require 'cs582.scripts.cutscene'
require 'cs582.scripts.oldladygoods'
require 'base.scripts.util'		-- timedRepeat is now found here.  i'm gonna end up with a thread/ent lib soon ...

-- todo - super-isze this?  useful for all?
function walkTo(from,to,closeDist)
	-- todo - factor in stalls/timeouts
	if not closeDist then closeDist = 1.5 end	--todo - factor in bbox's

	if to:getPosX() < from:getPosX() then from:setLeft(true)
	else from:setLeft(false)
	end

	while math.abs(from:getPosX() - to:getPosX()) > closeDist do
		if to:getPosX() < from:getPosX() then
			from:setVelX(-5)
			from:setLeft(true)
		else
			from:setVelX(5)
			from:setLeft(false)
		end
		sleep(0)
	end
end

-- a lerp.  a hack.  i need some better script basis functions
function flyTo(from,to,duration)
	local delta = to - from:getPos()
	local startTime = getTime()
	local endTime = startTime + duration
	local start = vec2:new(from:getPos())
	timedRepeat(function(sofar)
		from:setPos(start + delta * (sofar / duration))
	end, duration)
	from:setPos(start + delta)
end

function chomp(eatee)
	for i=1,50 do
		local c
		local l = math.random()
		if eatee == lettuce then c = vec4:new(l, 1, l, 1)
		else c = vec4:new(.5, 0, 0, 1)		-- todo - make lettuce leaf sprite
		end
		local p = Particle:new{
			pos = eatee:getPos();
			vel = vec2:new(math.random()*2-1,math.random()*2-1)*3;
			radius = math.random()*.7+.3;
			color = c;
			life = (math.random()+1)/2;
		}
		p:setBlend(BLEND.DECAL)
		p.think = function(self)
			Particle.think(self)
			self.vel[2] = self.vel[2] + .1
		end
	end
end


-- ok for the river
-- spawn the old lady's goods.  lettuce, goat, wolf


animLoad('fish', {sprites={{file='fish.png',bbox={-2,-2,2,2}}}})
class('Fish', Renderable)
Fish.animGroup = 'fish'	-- why can't i just say Fish.group ?
Fish.zBias = -1.3

animLoad('boat', {sprites={{file='boat.png',bbox={-1.5,-1.5,1.5,1.5}}}})

entclass('Boat', Collidable)
Boat.buoyancy = 60
Boat.zBias = -1.3
Boat.lastTouchTime = -1
Boat.animGroup = 'boat'
Boat.bbox = box2:new(-1,0,1,1)
function Boat:ctor(...)
	Boat.super.ctor(self, ...)
--	self.massInv = 1/2	-- i need ground entities working ... and not stopping ...
end

function Boat:think()
	Boat.super.think(self)
	if mapGetType(self:getPosX(), self:getPosY() + .25, self:getLayer()) == MAPTYPE.Liquid then
		self:setVelY(self:getVelY() - self.buoyancy * getDeltaTime() / self:getMassInv())
	end
end

Spawnable(Boat)

function boatTouch(self, other)
	if other ~= player then return end
-- with useGravity turned off, the contact normal turns off as well ... hmm. ..
	if self:getContactNormalY() < .5 then return end	-- only touching on top
	if self.inCutscene then return end
	if self.lastTouchTime + 1 > getTime() then return end	-- give em a sec to doc

	-- which side are we closest to?	
	local rightDist = math.abs(self:getPosX() - rightshore:getPosX())
	local leftDist = math.abs(self:getPosX() - leftshore:getPosX())
	local midway = (leftshore:getPosX() + rightshore:getPosX()) * .5
	
	local destshore = rightshore
	local destdir = 1
	if leftDist > rightDist then
		destshore = leftshore
		destdir = -1
	end

	self.inCutscene = true

	-- cross the river
	fork(	--cutscene(player,
	 function()
		local checkForEatery = false
		local killedTheGoat = false

		while math.abs(self:getPosX() - destshore:getPosX()) > .5 do
			self:setVelX(destdir * 10)
			
			-- i still have physics issues to work out
			player:setPosX(self:getPosX())
			player:setVelX(0)

			if castnumber(persist.story) == 2 then
			
				-- if we pass the midpoint and there's a mistake (i.e. wolf+goat or goat+lettuce on one side)
				if not checkForEatery and not killedTheGoat then
					if (destshore == rightshore and self:getPosX() > midway)
					or (destshore == leftshore and self:getPosX() < midway) then
						checkForEatery = true
						
						for i,v in ipairs{
							{'wolf', 'goat'},
							{'goat', 'lettuce'}
						} do
							local eater = _G[v[1]]
							local eatee = _G[v[2]]

							if (eater:getPosX() < leftshore:getPosX() and eatee:getPosX() < leftshore:getPosX())
							or (eater:getPosX() > rightshore:getPosX() and eatee:getPosX() > rightshore:getPosX())
							then
								killTheDrowningThread = true
								wait(drowningThread)

								-- why is this not working for long? because the tag system is messing it up.
								-- todo - replace tag camera clipping with something better
								player.disableInput = true
								player.destViewpos:set(eater:getPos())

								sleep(1)
								-- todo - factor size
								player.destViewpos:set(eatee:getPos())		-- why does this need to be in the busy loop?  what ever overrides it?
								walkTo(eater,eatee)
								sleep(.5)
								chomp(eatee)
								eatee:delete()
								sleep(2)
								player:dialog(v[1]..' ate the '..v[2]..'!!!')
								player:dialog("YOU LOST!!!")
								player:death()
								return
							end
						end
					end
				end
				
				-- if the wolf and the lettuce are on the other side
				-- and we're with the goat just passed the midpoint
				if not killedTheGoat
				and wolf:getPosX() > rightshore:getPosX() and lettuce:getPosX() > rightshore:getPosX()
				and goat:getPosX() > midway then
					killedTheGoat = true
				
					-- from here on out we dont need to worry about old ladys goods drowning
					killTheDrowningThread = true
					wait(drowningThread)

					self:setVelX(0)		-- stop in the way
					
					fish = Fish:new()
					fish:setPos(fishstart:getPos())
					
					-- wait for the fish to approach
					flyTo(fish, vec2:new(fishend:getPos()), 1)
					
					player:dialog("Feed me that goat if you want to live!")
					
					--give the user a moment to decide to throw the goat in
					-- if it does then have the boat go to the other side
					-- if it doesnt the we have to boss-fight or something
					while mapGetType(goat:getPosX(), goat:getPosY(), goat:getLayer()) ~= MAPTYPE.Liquid do
						sleep(0)
					end
					
					--kill it
					goat:death()

					-- fish swim to it
					flyTo(fish, vec2:new(goat:getPos()), 1)
					chomp(goat)

					--make sure its dead
					goat:delete()
					goat = nil

					-- back to the depths with you
					fork(function() flyTo(fish, vec2:new(fishstart:getPos()), 1) end)

					-- and ... go to the other side
					-- now we can allow the player to go through the end-of-level door or whatever
					-- or now the farmer comes	
				end
			end
			
			sleep(0)
		end

		-- make the player jump off
		player:setVelY(-20)
		player:setVelX(destdir * 7)
		
		sleep(1)	-- wait for him to land
		
		-- before we leave the boat
		-- if we're done
		if castnumber(persist.story) == 2 then
			if not goat and wolf:getPosX() > rightshore:getPosX() and lettuce:getPosX() > rightshore:getPosX() then
				-- wolf eats the lettuce!
				-- hey should you walk a little further?
				-- nah.
				player.disableInput = true
				player.destViewpos:set(lettuce:getPos())
				walkTo(wolf,lettuce)
				chomp(lettuce)
				lettuce:delete()
				-- unregister with global namespace.
				-- since these are registered engineside should they also be un-reg'd there too?
				lettuce = nil
				
				sleep(.7)
				
				-- and make the wolf MUTATE INTO SUPER WOLF
				timedRepeat(function(sofar)
					local scale = math.cos(math.pi + sofar * (2 * math.pi))	--[-1,1]
					scale = (scale * .5 + .5) * 2 + 1
					wolf:setScaleX(scale)
					wolf:setScaleY(scale)
				end, 2.5)
				wolf:makeBig()
				player.disableInput = false
				
				-- now he tries to rape you
				persist.story = 3
			end
		end
		
		self.inCutscene = false
		self.lastTouchTime = getTime()
	end)
end

followNames = {'lettuce','goat','wolf'}
function beginRiverGameOnTouch(self,other)
	if other ~= player then return end
	
	-- only run the dialogs once
	-- you can only use self:delete if you dont mind only assigning river waypoints once as well
	self:delete()

	-- the user has already delivered the goods so they're not there
	if castnumber(persist.story) >= 3 then return end

	-- have the lettuce goat and wolf stand in their designated places
	for i,name in ipairs(followNames) do
		local obj = _G[name]
		if obj then
			obj.followLeader = nil
			obj:setIgnoreEnts(false)
			obj.canBePickedUp = true
		end
	end

	-- the dog already ran away
	if castnumber(persist.story) >= 2 then return end
	
	-- it is such a tragedy when sleep is called by the main thrad
	-- i should write some protection against it
	cutscene(player, function()

		-- center on the dog's boat
		player.destViewpos:set(dogboat:getPos())
		
		-- can i make a "jump to" command?
		-- dog jumps on the boat
		dog:setLeft(false)
		--jump
		dog:setVelX(7)
		dog:setVelY(-10)
		sleep(.7)
		dog:setPosX(boat:getPosX())
		-- rejump
		dog:setVelX(7)
		dog:setVelY(-10)
		sleep(.7)
		dog:setVelX(0)
		dog:setPosX(dogboat:getPosX())

		-- show it taking off
		
		-- cross the river
		while math.abs(dogboat:getPosX() - rightshore:getPosX()) > .5 do
			dogboat:setVelX(10)
			dog:setPosX(dogboat:getPosX())
			dog:setVelX(0)
			player.destViewpos:set(dogboat:getPos())
			sleep(0)
		end
		
		-- wait for the boat to stop
		sleep(.5)
		
		--jump out
		dog:setVelX(10)
		dog:setVelY(-15)
		
		--throw a flame
		
		-- burn it down!
		
		-- make it sink
		
		dogboat:setAngle(180)
		dogboat.think = function(self) Collidable.think(self) end
		setTimeout(function() dogboat:delete() end, 5)
		
		-- and walk away
		timedRepeat(function() dog:setVelX(10) end, 2)
		
		player.destViewpos:set(player:getPos())
		
		sleep(.3)	--recenter
		
		-- and remove the dog.  he walked away
		dog:delete()

		persist.story = 2
	
		player:dialogDuration(1, "stand on a passenger and hold the clicker down to carry it")
	end)
end

function endRiverGameOnTouch(self,other) end

killTheDrowningThread = false
drowningThread = nil	-- namesake
function keepFromDrowning()

	local midway = (leftshore:getPosX() + rightshore:getPosX()) * .5
	
	while not killTheDrowningThread do
		sleep(0)

		for i,name in ipairs(followNames) do
			local obj = _G[name]
			
			if mapGetType(obj:getPosX(), obj:getPosY(), obj:getLayer()) == MAPTYPE.Liquid then
				--kill it
				obj:death()
				-- wait five seconds
				--  and game over
				fork(function()
					sleep(1)
					dialogPrompt(name.." can't swim!!!")
					dialogPrompt("YOU LOST!!!")
					player:death()
				end)
				return
			end
		end
		
		if mapGetType(player:getPosX(), player:getPosY(), player:getLayer()) == MAPTYPE.Liquid
		and player.pickup		-- todo - make sure its one of the three?
		and (player:getPosX() > midway) ~= (boat:getPosX() > midway)	-- and we're on the other side of the shore than the boat
		then
			-- im gonna kill this thread so fork somewhere new
			killTheDrowningThread = true
			cutscene(player, function()
				wait(drowningThread)
				dialogPrompt('OH NO it panics and you drown')
				player:death()
			end)
		end
	end
end

function onClientSpawn(e)
	player = e	-- set up the global

	-- i cant access map ent global names off the bat ...
	fork(function()
		sleep(.01)
	
		local story = castnumber(persist.story)

		-- dog and dogboat not needed after story 2	
		-- do this before spawning the old lady's goods because that takes a while
		if story >= 2 then
			dog:delete()
			dogboat:delete()
		end
		
		-- have the guys follow us through
		if story >= 1 and story <= 2 then
			spawnOldLadyGoods(player:getPos(), player)
			drowningThread = fork(keepFromDrowning)
		end

		--spawn the big wolf
		if story == 3 then
			wolf = Wolf:new()
			wolf:setPos(bigwolfplace:getPos())	--setpos before making big or fallthru
			wolf:makeBig()
		end
	end)
end
