require 'lolo.scripts.movable'
require 'base.scripts.clientinput'
require 'base.scripts.client'		--createClientStartClass
require 'lolo.scripts.shot'
require 'base.scripts.gameapi'

-- i need to put this somewhere where everyone will get to it
-- gameapi is soon to degen so i'll fill it with junk for the time being
-- of course looking at it i'm this close to letting the user type in the filename in the sprite box ...
-- which makes one wonder why they'd even need a separate sprite rather than the tile itself ...
animLoad('tree', 'tree.png')
animLoad('stone', 'stone.png')

-- here is our mod player
-- its gonna be like the original player except
-- i'm gutting the weapon system
-- and gonna put in more control for scripting
-- and do more with the whole grabbing objects thing ...

animLoad('lolo', 'player.anim')

-- here's my clientKeyXXX(this->in.input_cmd, INKEY_YYY) replacement:
-- self.input.key.YYY.XXX
-- where YYY is (engine -> script)
-- UP		up
-- DOWN		down
-- LEFT		left
-- RIGHT	right
-- ATTACK	attack
-- HOOK		alt
-- WEAPPREV	weapPrev
-- WEAPNEXT	weapNext
-- where XXX is (engine -> script)
-- State	state
-- Up		isUp
-- Down		isDown
-- Press	isPressed
-- Release	isReleased

--typical player entities are Collidable, but for Lolo we'll do all the hit detection ourselves
entclass('Player', LoloMove)

Player.animGroup = 'lolo'
Player.bbox = box2:new(0.4)
Player.shots = 0
Player.speed = 10
Player.viewpos = vec2:new(6.5)

function Player:ctor(so)
	player = self	--keep track of me

	Player.super.ctor(self, so)
	self:init(self:getPos())
end
	
function Player:init(pos)
	self:setPos(pos)

	self.destPos = vec2:new(pos)
	
	self.shots = 0
	
	self.disableInput = nil
	self.dead = nil
	self.zBias = Player.super.zBias - 0.1		-- a little above all we walk over
	
	-- for engine binding
	-- soon to be abstracted for all entities ...
	self.input = ClientInput:new()
	
	--spawn all!
	self:updateTags(-1)
end

function Player:updateTags(userTag)	-- void (entity, int)
	spawnObjSystemUpdateTags(userTag, self.tag)
	self.tag = userTag
end
	
function Player:updateTagsFromPos(pos)	-- void (entity, vec2f)
	local userTag = mapGetTag( math.floor(pos[1]), math.floor(pos[2]) )
	self:updateTags(userTag)
end
	
function Player:update()
	self:updateTagsFromPos(self:getPos())
end

function Player:fireShot()
	if self.shots <= 0 then return end
	self.shots = self.shots - 1
	Shot:new(self:getPos(), self.dir)
end

function Player:addNumShots(numShots)
	self.shots = self.shots + numShots
end

function Player:think()

	-- calc moveCmd state before running super.think
	-- so it knows where to go
	self.moveCmd = nil

	--recent hack
	-- try to cut the wire when the script says so
	if self.dead or self.disableInput then
		self.input:setcmd(0)
		self.input.mouse.active = false
	else 
		if self.input.key.up.isDown then	self.moveCmd = SIDE.UP		end
		if self.input.key.down.isDown then	self.moveCmd = SIDE.DOWN	end
		if self.input.key.left.isDown then	self.moveCmd = SIDE.LEFT	end
		if self.input.key.right.isDown then	self.moveCmd = SIDE.RIGHT	end
--[[
print('tostring(self.input) = '..tostring(self.input))
print('tostring(self.input.key) = '..tostring(self.input.key))
print('tostring(self.input.key.up) = '..tostring(self.input.key.up))
print('tostring(self.input.key.up.isUp) = '..tostring(self.input.key.isUp))
if self.input.key.up.isDown then print('up is down!') end
--]]
		-- store the direction of the user - for firing shots
		if self.moveCmd then self.dir = self.moveCmd end
		
		if self.input.key.attack.isPressed then
			self:fireShot()
		end
		
		if self.input.key.alt.isPressed then	--suicide
			-- do a chest touch to kill all entities
			-- now find the door and open it
			for i,e in pairs(_ents) do
				-- if e is an egg or e is a monster then destroy it
				-- keep the framers
				-- keep the chest
				-- keep the player
				-- keep the door
				if e:isa(LoloBase) then
					e:onChestOpen()
				end
			end
			-- then kill yourself
			self:die()
			return
		end
	end

	-- do this after determining the movecmd
	Player.super.think(self)
	if not self:isActive() then return end
	
	-- set movement for the player here
	do
		local seq = 'stand'
		if self.moveCmd then seq = 'walk' end
		
		if self.dir == SIDE.UP then seq = seq .. 'Up'
		elseif self.dir == SIDE.DOWN then seq = seq .. 'Down'
		else seq = seq .. 'Right'
		end
		self:setAnimSeq(seq)
	end

	-- update spawn tags and stuff
	-- this is not really needed in lolo gameplay
	-- just spawn all at level init instead
	self:update()
end

function Player:hitByShot(shot, shotPos, shotDir)
	-- players always allow shot pass thru
	return self.HIT_RESPONSE.MOVE_THRU
end
	
-- called when the player dies
-- who woulda thought.
Player.RESPAWN_TIME = 3
function Player:die()
	if self.dead then return end
	Puff(self:getPos())
	self:setAnimGroup('null')
	self.dead = true
	
	-- TODO  - more of a standard on level filename standards
	setTimeout(function()
		resetSession()
	end, self.RESPAWN_TIME)
end

function Player.clientUpdate(classObj)
	Player.super.clientUpdate(classObj)	-- hmm ...

	-- draw any shots the user has over on the side of the screen
	local sourceSeed = math.random(2000000000)	-- any way to grab the actual #?
	for i = 1,net.shots do
		math.randomseed((i + 1) * 7)	math.random()	math.random()
		drawSprite(
			vec2:new(math.random()-1.5, 7*math.random()+1),	-- pos
			0,				-- angle
			{1,1},			-- scale
			{1,1,1,1},		-- color
			0,				-- shader
			BLEND.DECAL,	-- blend
			false,			-- post-fbo
			true,			-- lighting
			false,			-- flip
			'shot',			-- group
			'idle',			-- seq
			0,				-- frame
			-2)				-- depth
	end
	math.randomseed(sourceSeed)
end
Player:createNetTable{
	viewpos = 'vec2f';
	shots = 'int';
}

createClientStartClass(Player)
GameAPI.clientSpawnClass = PlayerStart

-- NOTE TO SELF
-- this runs at script load time
-- but its a per-client command
-- so we want it to run upon client connect
-- that typically occurs in the onClientConnect routine
-- but we want that per-map-specifyable as well
-- so consider using OOP principles there

cvarExec('snapCameraToTags 0')
viewTileSize(32)
