require 'lolo.scripts.movable'

animLoad('shot', 'ninjastar.png')
entclass('Shot', LoloMove)
Shot.isBlocking = false		-- let things not be blocked by the shot
Shot.speed = 200
Shot.animGroup = 'shot'
Shot.rotation = 20 * 360
function Shot:ctor(pos, dir)
	Shot.super.ctor(self)
	self:setPos(pos)
	self.dir = dir
end

function Shot:think()
	Shot.super.think(self)
	if not self:isActive() then return end
	
	self:setAngle(self:getAngle() + self.rotation * getDeltaTime())
	
	-- make it keep on moving forward
	if not self.moveCmd then self.moveCmd = self.dir end
end

function Shot:hitEdge(where)
	self:delete()
	return true		-- stop stuff
end

function Shot:cannotPassThru(maptype)
	return maptype == MAPTYPE.Solid
end

function Shot:hitWorld(where, typeUL, typeUR, typeLL, typeLR)
	if Shot.super.hitWorld(self,where,typeUL, typeUR, typeLL, typeLR) then
		self:delete()
		return true
	end
	return false
end

-- we're starting to tread on another entity
-- we have some return codes for a situation like this:
-- 1) stop moving
-- 2) keep moving and dont test for a block (move thru)
-- 3) keep moving and test for a block
function Shot:hitObject(what, pushDest, dir)
	return what:hitByShot(self, pushDest, dir)
end
