
-- do this so we can use these animations in our map
-- yoshis island snow trees

-- i added a hack to let you override the anim filename with a structure ... looks like it is a painful replacement
animLoad('mw2tree1', {sprites={{file = 'mw2_tree1.png'; bbox = {-2, -3.5, 2, .5}; }}})
animLoad('mw2tree2', {sprites={{file = 'mw2_tree2.png'; bbox = {-2.5, -4.5, 2.5, .5}; }}})


client = nil	-- entity

-- script functions


function onClientSpawn(client_) -- void / entity
	viewTileSize(32)
	if client then
		print("someone has already started the game.  you can watch but that's about it")
		return
	end
	client = client_
	
--[[
fork(function()
	while not client.clientAck do sleep() end
	parallel(function()
		Selatine:runTo(waypoint_battle1_Selatine)
	end, function()
		Paris:runTo(waypoint_battle1_Paris)
	end, function()
		CaptainEdalpho:walkTo(waypoint_campfire_Captain)
	end, function()
		Officer1:walkTo(waypoint_campfire_Officer1)
	end, function()
		Officer2:walkTo(waypoint_campfire_Officer2)
	end)
-- [==[
Battle:new{
	teams = {
		{Selatine, Paris, client=client, winCondition=CaptainEdalpho};
		{CaptainEdalpho, Officer1, Officer2};
	};
}
--]==]
	client:followTarget(Paris)
	client.control = true
end)
do return end
--]]

--[[
client:followTarget(Paris)
client.control = true
do return end
--]]
	-- fork because of all the dialog stuff
	-- dialog boxes have to be run on a separate thread for all the sleep calls they make use of
	client:fadeOut()				--fade out immediately
fork(function()
	while not client.clientAck do sleep() end

--	fork(function() while true do print(Selatine.cmd) sleep(0) end end)

--[[
Act 1

Scene 1:  Introduction  -  SELATINE, PARIS, OFFICERS, and CAPTAIN EDALPHO

The scene is a glen in the forest.  Nocturnal owls hoot in the distance, crickets chirp, and
in the distance a large beast can be heard walking about.  SELATINE and PARIS are around a
glowing fire, each in their own sleeping bag.  PARIS is laying back, eyes closed.  SELATINE
is sitting up, fully awake, staring up at the sky.  Beside PARIS is a halberd and his pack.
SELATINE rests her head on her pack; underneath lie a short sword and a dagger.
--]]

	client:fadeIn(3)					--fade in over a time
	
-- while the camera is fading in, the campfire should be animating/flickering
-- and both PCs should be inside single-frame animation loops of lying down


--[[
these will require some thought
since we can't exactly pass lua code to each client on each intended menu creation...
in fact, chances are they'll all have to be gutted and redone...
in fact, if we plan on sending text across the net, an amendment for them will have to be too...
of course if you want clients to create modifyable functiality menus then you utterly have to use lookup tables
--]]
--	client:dialogDuration(10, "SELATINE: Only two more days and we'll be in Culthullin.  To think, I'll see my home again. It's only been seven years.  And my brother again, too!  It's been ten years since he ran away.  I bet everything's changed.")
	client:dialog{
"SELATINE: Only two more days and we'll be in Culthullin.  To think, I'll see my home again.  It's only been seven years.  And my brother again, too!  It's been ten years since he ran away.  I bet everything's changed.";
	}

-- [Pauses, turns towards PARIS.]

	Selatine:setAnimSeq('hurt')
	sleep(.3)

	client:dialog{
"Paris, are you even listening to me?";
"PARIS (Muffled from sleeping bag): Just enough so you're rambling won't keep me up all night.";
"SELATINE: Don't you care?  This is where I grew up.  Everything that happened here made me the person I am today.  Old friends, teachers, religion ... family.";
"PARIS: I hope you're not getting any ideas.  We're here strictly on business, and I don't think I have to remind you why it's been seven years since you last came here.";
"SELATINE: I know.  I left Culthullin-";
"PARIS: You were exiled.  Banished.  You didn't leave on your own free will.  Don't make it sound like you did.  I believe \"excommunicated\" was the term they used.  And if they ever catch you within ten leagues of town-";
"SELATINE: That won't happen.  The Church of Earth has their hands full enough as it is to worry about some silly girl.";
"PARIS: You never did tell me why it was you were excommunicated.";
"SELATINE: Well, there's plenty about you I don't know either.";
	}

	Paris:setAnimSeq('hurt')--"lying_down");
	sleep(.3)	--"lying_down_laugh");

-- [Laughs.]
	client:dialog(
"PARIS: I guess that's why you keep a poor messenger boy like me around.")

	client:dialog(
"SELATINE: You have your moments.")
-- [Laughs and lies down in her sleeping bag.]

	sleep(.3)	--selatine "lying_down_laugh");
		--selatine "lying_down");

	client:dialog(
"You are right, though.  If we didn't keep enough secrets from each other, I'm afraid we'd just get boring-")

	client:dialog(
"PARIS: Quiet!")

-- [Quickly gets up, draws up his spear from the ground beside him.  Begins looking around.
-- Speaks in a whisper now.]

-- here's where things are messing up ...

--	Paris:execSeqDelay('stand_d', .3)	--"stand_up"	);
	Paris:setAnimSeq('stand_d')
	Paris:walkTo(halbred)			--built-in state, combined with movement targets

	Paris:execSeqDelay('hurt', .3)
	--Paris.idleseq = 'hurt'
	--Paris.seq = 'hurt'
	--sleep(.3)
	--execAnimSeq	(Paris,	"kneel_down");
	--execAnimSeq	(Paris,	"pick_up_item_kneeled_down");	//something here, exec in bg while the item gets picked up (?)

	Paris:pickUpItem(halbred)
	Paris:setAnimSeq('stand_d')
	--Paris:execSeqDelay('stand_d', .3)	--"stand_up"	);

	client:dialog(
"Someone's coming.  Kill the fire.")


--[[
SELATINE gets out of her bag, quickly puts out the flame, and picks up the sword and long
dagger from under her pack.  She puts out the flames quickly and hides in the trees twenty
feet away from Paris.  Two OFFICERS enter followed by CAPTAIN EDALPHO.  They are obviously
flustered and rushed.  They inspect the camp together.
--]]
	parallel(function()
		Selatine:execSeqDelay('stand_d', .3)		--"stand");
		Selatine:walkTo(campfire)
		
		parallel(function()
			campfire:goOut(1)
		end, function()
			Selatine:execSeqDelay('walk_l',1)
			--execAnimSeq	(Selatine,		"kick_out_the_fire");
		end)

		Selatine:walkTo(sword)

		Selatine:execSeqDelay('hurt', .3)
		--execAnimSeq	(Selatine,		"kneel_down");
		--execAnimSeq	(Selatine,		"pick_up_item_kneeled_down");	//something here, exec in bg while the item gets picked up (?)

		Selatine:pickUpItem(sword)
		Selatine:execSeqDelay('stand_d', .3)			--"stand_up");
		Selatine:runTo(waypoint_trees_Selatine)
	end, function()
		Paris:runTo(waypoint_trees_Paris)
	end)
	
	Paris:setAnimSeq('stand_d')
	Selatine:setAnimSeq('stand_d')

	parallel(function()
		CaptainEdalpho:walkTo(waypoint_campfire_Captain)
	end, function()
		Officer1:walkTo(waypoint_campfire_Officer1)
	end, function()
		Officer2:walkTo(waypoint_campfire_Officer2)
	end)
	
	client:dialog{
"OFFICER 2: Do you think we lost them, sir?";
"EDALPHO: Maybe for now.  That decoy I set up won't last forever.";
"OFFICER 1: Sir, look here.  The fire is still warm.  Whoever was here isn't far off.";
	}

	CaptainEdalpho:lookAt(Officer1)

	client:dialog{
"EDALPHO: We must have surprised them in their sleep.  I guess it's more bandits or maybe agents of Dargothen.  They left their bags and packs here, too.";
"EDALPHO: [Shouts.]  Show yourselves! We are members of the Royal Court of Centullia, envoys to the Church of Earth on a noble mission.";
"OFFICER 2: Do you think they've gone, sir?";
"EDALPHO: Perhaps.  We certainly were loud enough.  I told the both of you to hush when you were telling those jokes.";
"OFFICER 1: Sorry, sir.";
"OFFICER 2: Sorry.  (Chuckles.)  They were funny though, sir.";
	}

	-- exec these both simulataneously
	parallel(function()
		Selatine:runTo(waypoint_battle1_Selatine)
		Selatine:lookAt(CaptainEdalpho)
	end, function()
		Paris:runTo(waypoint_battle1_Paris)
		Paris:lookAt(CaptainEdalpho)
	end)

	CaptainEdalpho:lookAt(Selatine)

--[[
EDALPHO Turns his back on SELATINE and PARIS to address the officers.  Lightens his frame,
and begins to relax, but it is too late.  SELATINE and PARIS are upon him in an instant and
the battle begins.
--]]

--[[
BATTLE 1.1.1:
CAPTAIN EDALPHO and TWO OFFICERS
Vs.
SELATINE and PARIS
Objectives:  Defeat Captain Edalpho
--]]
	Battle:new{
		teams={
			{Selatine, Paris, client=client, winCondition=CaptainEdalpho};
			{CaptainEdalpho, Officer1, Officer2};
		};
	}
	function getUpIfDown(who)
		if who.charInfo.hp <= 0 then
			who.charInfo.hp = 10
			who:setLeft(true)
			who:setAnimIdleSeq('stand')
			who:execSeqDelay('hurt',1)	-- hurt is mirrored atm
			who:setLeft(false)
		end
	end
	parallel(function()
		sleep(.5)
		getUpIfDown(CaptainEdalpho)
	end, function()
		sleep(1 + math.random())
		getUpIfDown(Officer1)
	end, function()
		sleep(1 + math.random())
		getUpIfDown(Officer2)
	end)
	CaptainEdalpho:lookAt(Selatine)

	client:dialog{
"EDALPHO: Sel, is that you?";
"SELATINE: Terrani?  What are you doing?";
"EDALPHO: It's now Royal Captain Terrani Pilip Edalpho, ambassador to the Church of Earth. No, Sel, you don't have anything to worry.  I wouldn't turn in an old friend. Besides, Magni will be thrilled to know I ran into you.";
"SELATINE: I was planning on getting in touch with her.";
-- (Asks skeptically.  Has never heard that nickname before.)
"PARIS: Sel? Selatine, who is this?";
"EDALPHO: An old friend of Sel's.  We grew up together:  her, my sister, and myself.  Hard to believe things have changed so much.  It's been years since I saw you last.";
"SELATINE: Too long, Ed.  How is Magni?";
"EDALPHO: Oh, a lot has changed since you left.  Magni's made quite a career out of the church.  There'll be more time to talk about old times later.";
"EDALPHO: We are in a bit of a rush.  I know you can't travel with us, but perhaps we could share the fire for the evening?";
"SELATINE: That'd be great, Ed.  We've got a lot to catch up on.";
"PARIS: ...";
	}

--[[
PARIS eyes her and Edalpho suspiciously.  He does not trust Edalpho or anyone wearing royal
insignia.  However, he builds the fire again without complaint.
--]]

	-- fork this - do it in the background
	fork(function()
		Paris:walkTo(waypoint_campfire)
		
		parallel(function()
			Paris:execSeqDelay('hurt', 1)
			--execAnimSeq	(Paris,	"kneel_down");
			--execAnimSeq	(Paris,	"build_campfire");
		end, function()
			campfire:startUp(1)		--"flame");
		end)
		
		Paris:lookAt(CaptainEdalpho)
	end)

	client:dialog{
"EDALPHO: You know, you should be careful out here.  There are a lot of reports of bandits in record numbers. With all the refugees on the road these days, the bandits are robbing and plundering without mercy.";
"SELATINE: Well, we'll be able to take care of our own.  We took care of you, you know.";
"EDALPHO: [Laughs.]  Do you think I'd try to hurt my old childhood friend?  Even if I didn't recognize her immediately?";
"EDALPHO: I'd like to talk all night with you, but my men and I have a long day ahead of us again tomorrow.  We need to get our rest while we can.";
"SELATINE: That's all right.  Just be sure to say hello to Magni for me when you see her.";
"EDALPHO: I'll do that, Sel.";
"PARIS: May I ask you a question, Captain?";
"EDALPHO: By all means.";
"PARIS: What exactly is it you and your men were running from?";
"EDALPHO: We don't exactly know.  I'd rather not speculate on it, either.  However, I do suggest you pack up as quickly as possible and stay away from the main road. These are not exactly friendly times.";
"SELATINE: Does this have to do with the rumors we've heard about Steward Banthius?";
"EDALPHO: Perhaps.  But please, no more questions.  I'll see you again, soon, if you are headed to Culthullin. There we'll be able to speak again.  As for now, I need my rest.";
"SELATINE: Of course.";
	}

	client:fadeOut(3)

-- Camera fades out.  Scene ends.

	-- fade in and give user control of Paris
	client:followTarget(Paris)
	client:fadeIn(1)
	client.control = true
end)	-- end the forked function
end		-- end the onclientspawn function
